let Genode = env:DHALL_GENODE

let Prelude = Genode.Prelude

let XML = Prelude.XML

in  { indexInfo =
        "Switched ethernet bus"
    , runtime =
        { resources =
            { ram = Genode.units.MiB 4, caps = 96 }
        , binary =
            "nic_bus"
        , provides =
            [ "nic" ]
        , requires =
            [] : List { label : Optional Text, service : Text }
        , roms =
            [ "nic_bus" ]
        , config =
            XML.text "<config><default-policy/></config>"
        }
    }
